#ifndef _DEFS_H
#define _DEFS_H

#include <allegro.h>
#include "pacman.h"
#include "textdat1.h"
#define VERSION_INFO   "--------------- Pacman  v1.00 ---------------\n"

typedef struct
{
   int
      x,
      y;
} POSITION;

typedef struct   /* data about the level */
{
   char
      name[41],
      reserved[64];
   POSITION
      power_pills_pos[6];
   POSITION
      ghost_start_pos,
      pacman_start_pos;
   int
      level_data[14][20],
      food_pos[14][20];
} LEVEL_DATA;

typedef struct
{
   int
      x,
      y,
      x_offset,
      y_offset,
      direction,
      next_dir,
      cur_frame,
      state;
} PLAYER;    /* This is also used for the ghosts. */

/*  The following is for doing dirty rectangle updating of the game
    screen.  The units will not be pixel across the screen, but
    in tiles (32x32 pixels).
*/

#define UPDATE_BACK      0
#define UPDATE_SPRITE    1

struct update_rect;

struct update_rect
{
   struct update_rect
      *next;
   BITMAP
      *sprite;
   int
      type;
   int
      x_top,
      y_top,
      x_bottom,
      y_bottom;
};

typedef struct update_rect UPDATE_RECT;


#endif  /* _DEFS_H */
