#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <allegro.h>

#include "defs.h"
#include "globals.h"
#include "text.h"


int
   text1_yoffset[93] = {1, 0, 0, 0, 0, 0, 1,-1,-1, 5,
                        5,13, 7,12, 0, 0, 0, 0, 0, 0,
                        0, 0, 0, 0,-1, 4, 4, 3, 3, 3,
                        2, 0, 2, 0, 1, 2, 0, 0, 1, 1,
                        2, 0,-1, 1, 1, 1, 1, 1, 1, 1,
                        1, 1, 1, 1, 1, 1, 1, 1,-1, 0,
                       -1, 0,12,-2, 6, 2, 6, 2, 5, 2,
                        4, 1, 2, 0, 0, 0, 4, 5, 6, 6,
                        7, 6, 5, 3, 5, 6, 5, 5, 5, 5,
                       -2,-2,-2};

void NewPrintf(BITMAP *dest, int x, int y, char *format, ...)
{
   va_list
      args;
   char
      tmp[128];
   int
      i,
      begin_x = x;
   BITMAP
      *bmp;

   va_start(args, format);
   vsprintf(tmp, format, args);
   va_end(args);

   for(i = 0; tmp[i]; i++)
   {
      if(tmp[i] == 32)
      {
         x += 8;
      } else if(tmp[i] == '\n')
      {
         y += 25;
         x = begin_x;
      } else if(tmp[i] == '\t')
      {
         x += 30;
      } else if(tmp[i] >= '!' && tmp[i] <= '~')
      {
         bmp = text1_data[tmp[i] - 33].dat;
         draw_sprite(dest, bmp, x, y + text1_yoffset[tmp[i] - 33]);
         x += bmp->w + 2;
      }
   }
}

/*
   Calculates the length of a string in pixels.
*/
int NewStrlen(char *string)
{
   int
      len = 0,
      i;
   BITMAP
      *bmp;

   for(i = 0; string[i]; i++)
   {
      if(string[i] == 32)
      {
         len += 8;
      } else if(string[i] == '\t')
      {
         len += 30;
      } else if(string[i] >= '!' && string[i] <= '~')
      {
         bmp = text1_data[string[i] - 33].dat;
         len += bmp->w + 2;
      }
   }

   return len;
}


/*
   Gets a string from the user.
   Editing begins at the end of the string passed.
*/
void GetString(int allow_space, int max_l, int x_start, int y, char *string)
{
   int
      x,
      pos,
      done = 0,
      width = 0,  /* width of character to erase */
      bottom = (allow_space) ? ' ' : '!';
   char
      k,
      c;
   char
      filename[51];
   BITMAP
      *bmp = NULL;


   memset(filename, 0, 51);

   NewPrintf(screen, x_start, y, string);

   x = NewStrlen(string) + x_start;
   pos = strlen(string);

   while(!done)
   {
      clear_keybuf();
      k = (char)readkey() & 0xFF;

      if(k == 13) /* enter */
      {
         string[pos] = 0;
         done = 1;
      } else if(k == 8) /* backspace */
      {
         if(pos > 0)
         {
            pos--;
            c = string[pos];
            string[pos] = 0;
            if(c == ' ')
            {
               width = 8;
            } else if(c >= '!' && c <= '~')
            {
               bmp = text1_data[c - 33].dat;
               width = bmp->w + 2;
            }
            x -= width;
            /* erase previous character */
            rectfill(screen, x, y - 1, x + width, y + 22, 0);
         }
      } else if(k >= bottom && k <= '~')  /* printable key */
      {
         if(pos < max_l)
         {
            string[pos] = k;
            if(k != ' ') /* if not a space */
            {
               bmp = text1_data[k - 33].dat;
               width = bmp->w + 2;
               /* Draw the character */
               draw_sprite(screen, bmp, x, y + text1_yoffset[k - 33]);
            } else /* if a space */
            {
               width = 8;
            }
            pos++;
            x += width;
         }
      }
   }

   clear_keybuf();
}
