#ifndef _UTIL_H
#define _UTIL_H

#include <allegro.h>
#include "defs.h"

/* For DeleteObject types */
#define DEL_ALL           1
#define DEL_FOOD1         2
#define DEL_GHOST_START   3
#define DEL_PACMAN_START  4
#define DEL_POWER_PILL    5
#define DEL_TILES         6


int FileExist(char *filename);
int ParseCommandArgs(int arg_count, char *arguments[], char *look_for);
int pat_scramble(char *data, unsigned long size);
void DoCommandArgs(int argc, char *argv[]);
void UpdateScreen(void);
void Credits(void);
void RenderTiles(LEVEL_DATA *data, int xs, int ys, int xe, int ye);
void Draw3DBox(BITMAP *bmp, int x1, int y1, int x2, int y2);
void RenderFood(LEVEL_DATA *data, int xs, int ys, int xe, int ye);
void DeleteObject(LEVEL_DATA *data, int x, int y, int type);
void RenderPowerPills(LEVEL_DATA *data, int xs, int ys, int xe, int ye);
int CountFood(LEVEL_DATA *data);
int CountPowerPills(LEVEL_DATA *data);
void SwapInt(int *a, int *b);
int YesNo(char *prompt);
int IsPowerPillAt(LEVEL_DATA *data, int x, int y);
void AddToHiscores(int sc);

#endif /* _UTIL_H */


